//+------------------------------------------------------------------+
//|                                                          MMI.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//|                                                         renexxxx |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1
//--- plot value
#property indicator_label1  "value"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRoyalBlue
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- input parameters
input int      period=20;
//--- indicator buffers
double         valueBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,valueBuffer);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int i,                           // Bar index
       Counted_bars;                // Number of counted bars
//--------------------------------------------------------------------
   Counted_bars=IndicatorCounted(); // Number of counted bars
   i=Bars-Counted_bars-1;           // Index of the first uncounted
   for(;i>0;i--)                      // Loop for uncounted bars
     {
      valueBuffer[i]=iMMI(NULL,PERIOD_CURRENT,period,PRICE_CLOSE,i);
     }
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                         iMMI.mq4 |
//|                                                         renexxxx |
//|                                http://www.stevehopwoodforex.com/ |
//+------------------------------------------------------------------+
//#property copyright "renexxxx"
//#property link      "http://www.stevehopwoodforex.com/"
//#property version   "1.00"
//#property strict
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
//void OnStart() {
//   for (int iShift=10; iShift >= 0; iShift--) {
//      PrintFormat("iMMI(EURUSD)[%d] = %5.5f", iShift, iMMI( "EURUSD", PERIOD_M15, 10, PRICE_CLOSE, iShift ) );
//   }
//}
//+------------------------------------------------------------------+
 
//+------------------------------------------------------------------+
//| iMedian: return the median of a set of price values              |
//+------------------------------------------------------------------+
double iMedian( string symbol, int timeFrame, int lperiod, int applied_price, int shift ) {
   double array[];
   ArrayResize(array, lperiod);
  
   for (int iShift=lperiod-1; iShift >= 0; iShift--) {
      array[iShift] = iMA( symbol, timeFrame, 1, 0, MODE_SMA, applied_price, iShift+shift );
   }
   ArraySort(array, WHOLE_ARRAY, 0, MODE_ASCEND);
  
   if ( (int)MathMod(lperiod,2.0) == 1 ) {
      return( array[(lperiod-1)/2] );
   }
   else {
      return( ( array[(lperiod/2)] + array[(lperiod/2)-1] )/2.0 );
   }
}
//+------------------------------------------------------------------+
//| iMMI: return the 'mean-ness' of a set of price values            |
//+------------------------------------------------------------------+
double iMMI( string symbol, int timeFrame, int lperiod, int applied_price, int shift ) {
   // Can not handle a period of less than or equal to 1. Return something silly.
   if ( lperiod <= 1 ) return( DBL_MIN );
  
   double prevPrice, currPrice;
   double median = iMedian( symbol, timeFrame, lperiod, applied_price, shift );
  
   int nh=0, nl=0;
   for(int iShift=lperiod-1; iShift >= 1; iShift--) {
      
      prevPrice = iMA( symbol, timeFrame, 1, 0, MODE_SMA, applied_price, iShift+shift );
      currPrice = iMA( symbol, timeFrame, 1, 0, MODE_SMA, applied_price, iShift+shift-1 );
      if ( (currPrice > median) && (currPrice > prevPrice) ) nl++;
      else if ( (currPrice < median) && (currPrice < prevPrice) ) nh++;
   }
   return( 100.0*(nl+nh)/(lperiod-1) );
}